#include "Finch_ch.h"
#include <ch.h>


EXPORTCH void Finch_Finch_chdl(void *varg){
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c=new Finch();
    
    Ch_VaStart(interp, ap, varg);
    Ch_CppChangeThisPointer(interp, c, sizeof(Finch));
    Ch_VaEnd(interp, ap);
}

EXPORTCH void Finch_dFinch_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    if (Ch_CppIsArrayElement(interp))
        c->~Finch();
    else
        delete c;
    Ch_VaEnd(interp, ap);
    return;
}

EXPORTCH int Finch_connect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    
    retval = c->connect();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_disConnect_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    
    retval = c->disConnect();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_setLED_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int red;
    int green;
    int blue;
    int retval;

    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    red = Ch_VaArg(interp, ap, int);
    green = Ch_VaArg(interp, ap, int);
    blue = Ch_VaArg(interp, ap, int);
    retval = c->setLED(red, green, blue);
    
    Ch_VaEnd(interp, ap);
    return retval;
}


EXPORTCH int Finch_setMotors_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int leftWheelSpeed;
    int rightWheelSpeed;
    int duration;
    int retval;

    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    leftWheelSpeed = Ch_VaArg(interp, ap, int);
    rightWheelSpeed = Ch_VaArg(interp, ap, int);
    if(Ch_VaCount(interp, ap) == 0){
        retval = c->setMotors(leftWheelSpeed, rightWheelSpeed);
    }
    else if(Ch_VaCount(interp, ap) == 1){
        duration = Ch_VaArg(interp, ap, int);
        retval = c->setMotors(leftWheelSpeed, rightWheelSpeed, duration);
    }
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_noteOn_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int frequency;
    int duration;
    int retval;

    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    frequency = Ch_VaArg(interp, ap, int);
    if(Ch_VaCount(interp, ap) == 0){
        retval = c->noteOn(frequency);
    }
    else if(Ch_VaCount(interp, ap) == 1){
        duration = Ch_VaArg(interp, ap, int);
        retval = c->noteOn(frequency, duration);
    }
    
    Ch_VaEnd(interp, ap);
    return retval;
}


EXPORTCH int Finch_noteOff_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->noteOff();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH double Finch_getTemperature_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    double retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getTemperature();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH double* Finch_getAccelerations_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    double *retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getAccelerations();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int* Finch_getLightSensors_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int *retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getLightSensors();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int* Finch_getObstacleSensors_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int *retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getObstacleSensors();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_wasTapped_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->wasTapped();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_wasShaken_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->wasShaken();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_isObstacleLeftSide_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->isObstacleLeftSide();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_isObstacleRightSide_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->isObstacleLeftSide();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_getLeftLightSensor_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getLeftLightSensor();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_getRightLightSensor_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getRightLightSensor();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH double Finch_getXAcceleration_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    double retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getXAcceleration();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH double Finch_getYAcceleration_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    double retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getYAcceleration();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH double Finch_getZAcceleration_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    double retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->getYAcceleration();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_isBeakUp_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->isBeakUp();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_isBeakDown_chdl(void *varg) {
ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->isBeakDown();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_isFinchLevel_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->isFinchLevel();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_isFinchUpsideDown_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->isFinchUpsideDown();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_isRightWingDown_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->isRightWingDown();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_isLeftWingDown_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->isLeftWingDown();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_counter_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    int retval;
    
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    retval = c->counter();
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH void Finch_keepAlive_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
        
    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    
    c->keepAlive();
    
    Ch_VaEnd(interp, ap);
    return;    
}

EXPORTCH int Finch_finchRead_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    unsigned char *bufToWrite;
    unsigned char *bufRead;
    int retval;

    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    bufToWrite = Ch_VaArg(interp, ap, unsigned char *);
    bufRead = Ch_VaArg(interp, ap, unsigned char *);
    retval = c->finchRead(bufToWrite, bufRead);
    
    Ch_VaEnd(interp, ap);
    return retval;
}

EXPORTCH int Finch_finchWrite_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    unsigned char *bufToWrite;
    int retval;

    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    bufToWrite = Ch_VaArg(interp, ap, unsigned char *);
    retval = c->finchWrite(bufToWrite);
    
    Ch_VaEnd(interp, ap);
    return retval;
}

/*
EXPORTCH unsigned int keepAliveEntryPoint_chdl(void *varg) {
    ChInterp_t interp;
    ChVaList_t ap;
    class Finch *c;
    void *pThis;
    unsigned int retval;

    Ch_VaStart(interp, ap, varg);
    c = Ch_VaArg(interp, ap, class Finch *);
    pThis = Ch_VaArg(interp, ap, void *);
    retval = c->keepAliveEntryPoint(pThis);
    
    Ch_VaEnd(interp, ap);
    return retval;
}
*/

